<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>

<title>Dusting Simulator</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="dust.css">
<style>

.topnav {
  overflow: hidden;
  background-color: #333;
  top: 0;
  position: fixed;
  font-family:'Courier New';
}

.topnav a {
  float: left;
  color: #f2f2f2;
  text-align: center;
  padding: 14px 16px;
  text-decoration: none;
  font-size: 17px;
}

.topnav a:hover {
  background-color: #191970;
  color: black;
}

.topnav a.active {
  background-color: #66CDAA;
  color: white;
}
</style>
<body>
<div class="topnav">
  <a href="https://www.pokedata.ovh">Home</a>
  <a href="https://www.pokedata.ovh/standings">TCG Standings</a>
  <a href="https://www.pokedata.ovh/standingsVGC">VG Standings</a>
  <a href="https://www.pokedata.ovh/events">Pokémon Events</a>
</div><br><br><br>
<h2>PTCG Live Dusting Simulator</h2>
<p>
<p>
<table>
<tr>
<td>
<form method="post">
<h2><label for="set">Choose a set:</label></h2>
<div class="custom-select" style="width:400px;">
<select name="setid" id="setid"><optgroup>
<?php

function csv_to_array($filename='', $delimiter=',')
{
	if(!file_exists($filename) || !is_readable($filename))
		return FALSE;
	$header = NULL;
	$data = array();
	if (($handle = fopen($filename, 'r')) !== FALSE)
	{
		while (($row = fgetcsv($handle, null, $delimiter)) !== FALSE)
		{
			if(!$header)
				$header = $row;
			else
				$data[] = array_combine($header, $row);
		}
		fclose($handle);
	}
	return $data;
}

$sets = array();
$dataSets = csv_to_array('slots.csv', ',');

for($i = 0; $i < count($dataSets); $i++)
{
	$sets[$dataSets[$i]['set']] = $dataSets[$i]['name'];
}

$keys = array_keys($sets);

for($i = 0; $i < count($keys); $i++)
{
	echo '<option value="'.$keys[$i].'" ';
	echo (isset($_POST['setid']) && $_POST['setid'] == $keys[$i]) ? 'selected' : '';
	echo '>'.$sets[$keys[$i]].'</option>';
}

?>
</optgroup>
</select>
</div>
<br>
<h2><label for="set">Number of Packs:</label></h2>
<div class="custom-select" style="width:400px;">
<select name="sampleSize" id="sampleSize">
	<optgroup>
	<option value="1" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '1') ? 'selected' : ''; ?>>1</option>
	<option value="2" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '2') ? 'selected' : ''; ?>>2</option>
	<option value="5" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '5') ? 'selected' : ''; ?>>5</option>
	<option value="10" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '10') ? 'selected' : ''; ?>>10</option>
	<option value="20" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '20') ? 'selected' : ''; ?>>20</option>
	<option value="50" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '50') ? 'selected' : ''; ?>>50</option>
	<option value="75" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '75') ? 'selected' : ''; ?>>75</option>
	<option value="100" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '100') ? 'selected' : ''; ?>>100</option>
	<option value="200" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '200') ? 'selected' : ''; ?>>200</option>
	<option value="300" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '300') ? 'selected' : ''; ?>>300</option>
	<option value="400" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '400') ? 'selected' : ''; ?>>400</option>
	<option value="500" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '500') ? 'selected' : ''; ?>>500</option>
	<option value="541" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '541') ? 'selected' : ''; ?>>541</option>
	<option value="600" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '600') ? 'selected' : ''; ?>>600</option>
	<option value="700" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '700') ? 'selected' : ''; ?>>700</option>
	<option value="800" <?php echo (isset($_POST['sampleSize']) && $_POST['sampleSize'] == '800') ? 'selected' : ''; ?>>800</option>
	</optgroup>
</select>
</div>

<br>
<h2><label for="set">Full Set on PTCGO:</label></h2>
<div class="custom-select" style="width:400px;">
<select name="fullSet" id="fullSet">
	<optgroup>
	<option value="0" <?php echo (isset($_POST['fullSet']) && $_POST['fullSet'] == '0') ? 'selected' : ''; ?>>No</option>
	<option value="1" <?php echo (isset($_POST['fullSet']) && $_POST['fullSet'] == '1') ? 'selected' : ''; ?>>Yes</option>
	</optgroup>
</select>
</div>
If No : <br>
<input type="checkbox" id="common" name="common" value="1" <?php echo (isset($_POST['common']) && $_POST['common'] == '1') ? 'checked' : ''; ?>>
<label for="common"> Full set of commons</label><br>
<input type="checkbox" id="uncommon" name="uncommon" value="1" <?php echo (isset($_POST['uncommon']) && $_POST['uncommon'] == '1') ? 'checked' : ''; ?>>
<label for="uncommon"> Full set of uncommons</label><br>

<br>
<input style="font-weight:bold;font-size: 20px;" type="submit" value="Run Simulation!">
</form>
</td>
<td style="width:50px">
</td>
<td style="text-align: right; vertical-align: top;">
<br>
<br>
<br>
<br>
<b style="color:blue">Legend:</b><br>
# :<br>
Name :<br>
Rarity :<br>
value :<br>
Dust :<br>
Cnt :<br>
</td>
<td style="text-align: left; vertical-align: top;">
<br>
<b style="color:red">New version (2023/02-03), based on Live real drop rates.</b><br>
<b style="color:red">I am missing most of the rates of the packs not in the shop, the ones available from codes : BW-XY-SM</b><br>
<b style="color:red">Thanks to: Robin, JPL, dragtap, Mister Burkes, GoGoGo12321 and Madareja for the help!</b><br>
<br>
card # in the set<br>
card name<br>
rarity of the card<br>
dust value for 1 copy<br>
dust generated by this card in the simulation<br>
number of times this card appears in the simulation<br>
</td>
</table>
<?php

if (!function_exists('str_contains'))
{
	function str_contains (string $haystack, string $needle)
	{
		return empty($needle) || strpos($haystack, $needle) !== false;
	}
}

if ($_SERVER['REQUEST_METHOD'] == 'POST')
{
	$sampleSize = isset($_POST['sampleSize']) ? $_POST['sampleSize'] : 400;
	$setCode = isset($_POST['setid']) ? $_POST['setid'] : 'swsh09';
	$fullSet = intval(isset($_POST['fullSet']) ? $_POST['fullSet'] : '0');
	
	$commons = 0;
	if(isset($_POST['common']))
		$commons = $_POST['common'];
	$uncommons = 0;
	if(isset($_POST['uncommon']))
		$uncommons = $_POST['uncommon'];
		
	$offset = 0;
	if($fullSet == 0)
	{
		$offset = 4;
	}
	
	$slots = array();
	$upgraded = array();
	$dataSets = csv_to_array('slots.csv', ',');
	
	$rarityLookup = csv_to_array('rarities.csv', ',');
	for($i = 0; $i < count($rarityLookup); $i++)
	{
		$rarityLookup[$i]['rarity'] = str_replace('Trainer ', '', $rarityLookup[$i]['rarity']);
		$rarityLookup[$i]['rarity'] = str_replace('Galarian ', '', $rarityLookup[$i]['rarity']);
		$rarityLookup[$i]['expansion'] = str_replace('SWSH10pt5', 'swshTCGxGO', $rarityLookup[$i]['expansion']);
	}

	for($i = 0; $i < count($dataSets); $i++)
	{
		$dataSets[$i]['rarity'] = str_replace('Trainer ', '', $dataSets[$i]['rarity']);
		$dataSets[$i]['rarity'] = str_replace('Galarian ', '', $dataSets[$i]['rarity']);
	}

	for($i = 0; $i < count($dataSets); $i++)
	{
		if($dataSets[$i]['set'] == $setCode)
		{
			if (!array_key_exists($dataSets[$i]['slot'], $slots))
			{
				$slots[$dataSets[$i]['slot']] = array();
				$upgraded[$dataSets[$i]['slot']] = array();
			}
			$upgrade = $dataSets[$i]['rarity'];
			if(strcmp($dataSets[$i]['upgrade'], "True") == 0)
			{
				$upgrade = '('.$dataSets[$i]['rarity'].')';
			}
			array_push($slots[$dataSets[$i]['slot']], $dataSets[$i]['rarity']);
			array_push($upgraded[$dataSets[$i]['slot']], $upgrade);
		}
	}
	
	$keys_slots = array_keys($slots);
	
	$nbSlots = count($slots);
	
	$sets = array();
	for($i = 0; $i < count($dataSets); $i++)
	{
		$sets[$dataSets[$i]['set']] = $dataSets[$i]['name'];
	}

	echo "<h2>".$sets[$setCode]." (".$setCode.") / ".$sampleSize." Packs</h2><p>";
	
	$dataCards = csv_to_array('cards.csv', ',');
	for($i = 0; $i < count($dataCards); $i++)
	{
		$dataCards[$i]['rarity'] = str_replace(' holo', ' Holo', $dataCards[$i]['rarity']);
		$dataCards[$i]['rarity'] = str_replace(' ultra', ' Ultra', $dataCards[$i]['rarity']);
		$dataCards[$i]['rarity'] = str_replace(' rare', ' Rare', $dataCards[$i]['rarity']);
		$dataCards[$i]['rarity'] = str_replace(' secret', ' Secret', $dataCards[$i]['rarity']);
		$dataCards[$i]['rarity'] = str_replace('Galarian ', '', $dataCards[$i]['rarity']);
		$dataCards[$i]['rarity'] = str_replace('Trainer ', '', $dataCards[$i]['rarity']);
	}
	
	$poolsColor = array();
	$arrayPulls = array();
	$arrayCounted = array();
	$arrayPullsDust = array();
	
	$cardsInRarityPool = array();
	$rarityPoolPerSlot = array();
	
	for($i = 0; $i < $nbSlots; $i++)
	{
		$rarityPoolPerSlot[$i] = array();
	}
	
	for($i = 0; $i < count($dataCards); $i++)
	{
		if($dataCards[$i]['set'] == $setCode)
		{
			$rarity = $dataCards[$i]['rarity'];
			if(str_contains($dataCards[$i]['rarity'], 'Shiny Rare'))
			{
				$dataCards[$i]['rarity'] .= ' (Shiny Vault)';
				$rarity .= ' (Shiny Vault)';
			}
			$rarity = str_replace(' (CLASSIC COLLECTION)', '', strtoupper($rarity));
						
			if($dataCards[$i]['std'] == 'True')
			{
				if(!isset($cardsInRarityPool[$rarity]))
				{
					$cardsInRarityPool[$rarity] = array();
				}
				array_push($cardsInRarityPool[$rarity], $dataCards[$i]['number'].' '.$dataCards[$i]['name']);
			}
			if($dataCards[$i]['foil'] == 'True')
			{
				$rarity .= strtoupper(' (Parallel Foil Set)');
				if(!isset($cardsInRarityPool[$rarity]))
				{
					$cardsInRarityPool[$rarity] = array();
				}
				array_push($cardsInRarityPool[$rarity], $dataCards[$i]['number'].' '.$dataCards[$i]['name'].'#foil');
			}
			
		}
	}
	
	
	//echo $setCardsCount.'<br>';
	//print_r($cardsInRarityPool);
	for($i = 0; $i < count($dataCards); $i++)
	{
		if($dataCards[$i]['set'] == $setCode)
		{
			$rarity = $dataCards[$i]['rarity'];
			$std = $dataCards[$i]['std'];
			if(str_contains($dataCards[$i]['rarity'], 'Shiny Rare'))
			{
				$dataCards[$i]['rarity'] .= ' (Shiny Vault)';
				$rarity .= ' (Shiny Vault)';
			}
			$name_rarity = $dataCards[$i]['name'].' '.$dataCards[$i]['rarity'];
			$setNb = $dataCards[$i]['number'];
			$rate = $dataCards[$i]['rate'];
			if(!str_contains($setNb, '025') && str_contains($setCode, 'swsh25'))
			{
				$rarity = $dataCards[$i]['rarity']." (Classic Collection)";
			}
			//echo $rarity."<br>";
			$dust = 0;

			$name_rarity = str_replace('Trainer ', '', $name_rarity);
			$name_rarity = str_replace('Galarian ', '', $name_rarity);

			$name_rarity = strtolower($name_rarity);
			
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('special illustration Rare')))
					$dust = 600;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('hyper Rare')))
					$dust = 1000;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('double Rare')))
					$dust = 250;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('illustration Rare')))
					$dust = 375;
			
			
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Gallery Holo Rare')))
					$dust = 250;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Gallery Ultra Rare')))
					$dust = 600;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Gallery Secret Rare')))
					$dust = 1000;
			
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('shiny rare gx')))
					$dust = 300;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('holo rare gx')))
					$dust = 250;
			
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('shiny rare')))
					$dust = 150;
				
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Holo Rare VSTAR')))
					$dust = 375;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Holo Rare VMAX')))
					$dust = 375;
			
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Radiant Rare')))
					$dust = 150;
				
			if($dust == 0)
				if(str_contains(substr($name_rarity, -2), strtolower(' V')))
					$dust = 250;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Uncommon')))
					$dust = 20;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Common')))
					$dust = 10;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Prism Star Rare')))
					$dust = 150;
					
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Ultra Rare')))
					$dust = 600;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Amazing Rare')))
					$dust = 150;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Secret Rare')))
					$dust = 1000;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Holo Rare Ex')))
					$dust = 250;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Holo Rare break')))
					$dust = 150;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Holo Rare')))
					$dust = 125;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Rainbow Rare')))
					$dust = 800;
			
			if($dust == 0)
				if(str_contains($name_rarity, strtolower(' VSTAR')))
					$dust = 375;
			if($dust == 0)
				if(str_contains($name_rarity, strtolower(' VMAX')))
					$dust = 375;
			
			if($dust == 0)
				if(str_contains($name_rarity, strtolower('Rare')))
					$dust = 100;
				
			
			$dataCards[$i]['dust'] = $dust;

			$name = $dataCards[$i]['number'].' '.$dataCards[$i]['name'];
			for($j = 0; $j < $nbSlots; $j++)
			{				
				if (!array_key_exists($j, $rarityPoolPerSlot))
				{
					$arrayPulls[$j] = array();
					$rarityPoolPerSlot[$j] = array();
				}
				for($look = 0; $look < count($rarityLookup); $look++)
				{
					if(strtoupper($setCode) == strtoupper($rarityLookup[$look]['expansion']))
					{
						if($j == $rarityLookup[$look]['slot'])
						{
							$rate = $rarityLookup[$look]['rate'] * 100;
							for($k = 0; $k < $rate; $k++)
							{
								array_push($rarityPoolPerSlot[$j], str_replace(' (CLASSIC COLLECTION)', '', str_replace('TRAINER ', '', strtoupper($rarityLookup[$look]['rarity']))));
							}
						}
					}
				}
				
				
			}
			$poolsColor[$name] = "LightGreen";
			$arrayPulls[$j][$name] = 0;
			$arrayCounted[$name] = 0;
			$arrayPullsDust[$name] = $dust;
		}
	}
	
	//print_r($rarityPoolPerSlot);
	//print_r($dataCards);
	
	for($j = 0; $j < $nbSlots; $j++)
	{
		$size = count($rarityPoolPerSlot[$j]);
		for($i = 0; $i < $sampleSize; $i++)
		{
			$key_rarity = $rarityPoolPerSlot[$j][rand(0,$size-1)];
			$sizeR = count($cardsInRarityPool[$key_rarity]);
			$key_card = $cardsInRarityPool[$key_rarity][rand(0,$sizeR-1)];
			
			//echo $j.'/'.$i.' : '.$key_rarity.'('.$sizeR.') / '.$key_card.'<br>';
			
			$arrayPulls[$j][$key_card] = $arrayPulls[$j][$key_card]+1;
		}
	}
	
	$html_data = '<table class="main">';
	$html_data .= "<thead><tr>";
	$html_data .= '<th colspan="5">Card</th>';
	for($i = 0; $i < count($slots); $i++)
	{		
		$html_data .= '<th>Slot '.$keys_slots[$i].'</th>';
	}
	$html_data .= "</tr></thead>";
	
	$html_data .= "<tbody>";
	$html_data .= "<tr>";
	$html_data .= '<td  colspan="5" style="text-align: center; vertical-align: middle; font-size: 12px;"></td>';
	for($i = 0; $i < count($keys_slots); $i++)
	{		
		$html_data .= '<td style="text-align: center; vertical-align: middle; font-size: 12px;">';
		for($j = 0; $j < count($slots[$keys_slots[$i]]); $j++)
		{
			$html_data .= $upgraded[$keys_slots[$i]][$j];
			$found = false;
			for($look = 0; $look < count($rarityLookup) && !$found; $look++)
			{
				if(strtoupper($setCode) == strtoupper($rarityLookup[$look]['expansion']))
				{
					if($i == $rarityLookup[$look]['slot'])
					{
						if((strtoupper($upgraded[$keys_slots[$i]][$j]) == strtoupper("Basic Energy (Parallel Foil Set)") && strtoupper($rarityLookup[$look]['rarity']) == strtoupper("Common (Parallel Foil Set)") && strtoupper($setCode) == strtoupper("SWSH12pt5") && $rarityLookup[$look]['rate']*100 < 10) || strtoupper($slots[$keys_slots[$i]][$j]) == strtoupper($rarityLookup[$look]['rarity']) || strtoupper($slots[$keys_slots[$i]][$j]) == strtoupper(str_replace("Trainer Gallery", "Galarian Gallery", $rarityLookup[$look]['rarity'])))
						{
							$html_data .= " / ".($rarityLookup[$look]['rate']*100)."%";
							$found = true;
						}
					}
				}
			}
			$html_data .= "</br>";
		}
		$html_data .= "</td>";
	}
	$html_data .= "</tr>";
	
	$html_data .= "<tr>";
		
	$CardCount = 0;
	
	$dust_gained = 0;
	
	$html_data .= '<tr>';
	$html_data .= '<td class="hnum">#</td>';
	$html_data .= '<td class="hname">Name</td>';
	$html_data .= '<td class="hval">rarity</td>';
	$html_data .= '<td class="hval">value</td>';
	$html_data .= '<td class="hdust">Dust</td>';
	for($k = 0; $k < count($keys_slots); $k++)
	{
		$html_data .= '<td class="hcnt">Count</td>';
	}
	$html_data .= '</tr>';
	for($i = 0; $i < count($dataCards); $i++)
	{
		if($dataCards[$i]['set'] == $setCode)
		{
			$html_data .= '<tr height="20px">';
			$html_data .= '<td class="Num"><div class="lim">';
			$html_data .= $dataCards[$i]['number'];
			$html_data .= '</div></td>';
			$html_data .= '<td class="Name"><div class="lim">';
			$html_data .= $dataCards[$i]['name'];
			$html_data .= '</div></td>';
			$html_data .= '<td class="val"><div class="lim">';
			$html_data .= $dataCards[$i]['rarity'];
			$html_data .= '</div></td>';
			$html_data .= '<td class="val"><div class="lim">';
			$nbCardsPulled = 0;
			$nbCardsPulledFoil = 0;
			for($j = 0; $j < count($keys_slots); $j++)
			{
				$nbCardsPulled += $arrayPulls[$j][$dataCards[$i]['number'].' '.$dataCards[$i]['name']];
				$nbCardsPulledFoil += $arrayPulls[$j][$dataCards[$i]['number'].' '.$dataCards[$i]['name'].'#foil'];
			}
			$dustGained = 0;
			$setOffset = 4;
			
			if(str_contains(strtolower($dataCards[$i]['name']), 'radiant ') || str_contains(strtolower($dataCards[$i]['rarity']), 'prism'))
			{
				$setOffset = 1;
			}
			if(str_contains(strtolower($dataCards[$i]['rarity']), 'common') && $commons == 1)
			{
				$setOffset = 0;
			}
			if(str_contains(strtolower($dataCards[$i]['rarity']), 'uncommon') && $uncommons == 1)
			{
				$setOffset = 0;
			}
			
			//echo $commons." - ".$uncommons." - ".$setOffset." - ".$dataCards[$i]['name']." - ".$dataCards[$i]['rarity']."<br>";
			if($dataCards[$i]['std'] == 'True')
			{
				
				if($fullSet == 1)
				{
					$dustGained += $nbCardsPulled * $dataCards[$i]['dust'];
				}
				else
				{
					$dTmp = $nbCardsPulled - $setOffset;
					if($dTmp > 0)
					{
						$dustGained += ($nbCardsPulled - $setOffset) * $dataCards[$i]['dust'];
					}
				}
			}
			if($dataCards[$i]['foil'] == 'True')
			{
				if($fullSet == 1)
				{
					$dustGained += $nbCardsPulledFoil * $dataCards[$i]['dust'];
				}
				else
				{
					$dTmp = $nbCardsPulledFoil - $setOffset;
					if($dTmp > 0)
					{
						$dustGained += ($nbCardsPulledFoil - $setOffset) * $dataCards[$i]['dust'];
					}
				}
			}
			$dust_gained += $dustGained;
			$html_data .= $dataCards[$i]['dust'];
			$html_data .= '</div></td>';
			$html_data .= '<td class="Dust"><div class="lim">';
			$html_data .= $dustGained;
			$html_data .= '</div></td>';
			for($k = 0; $k < count($keys_slots); $k++)
			{
				$html_data .= '<td class="Count"><div class="lim">';
				$html_data .= $arrayPulls[$k][$dataCards[$i]['number'].' '.$dataCards[$i]['name']];
				$html_data .= $arrayPulls[$k][$dataCards[$i]['number'].' '.$dataCards[$i]['name'].'#foil'];
				$html_data .= '</div></td>';
			}
		}
	}
	$html_data .= "</table>";
	//echo strval($CardCount).' cards<br>';
	echo '<h2>Dust Gained : <b  style="background:lightgreen">'.strval($dust_gained).' ~ '.strval(round($dust_gained/1025)).' VMax/VStar cards</b></h2><br>';
	
	echo $html_data;
}
?>
<div class="footer">This website is not affiliated with, sponsored or endorsed by, or in any way associated with The Pokemon Company International Inc/Nintendo/Creatures Inc./GAME FREAK Inc.</div>

<script>
var x, i, j, l, ll, selElmnt, a, b, c;
/*look for any elements with the class "custom-select":*/
x = document.getElementsByClassName("custom-select");
l = x.length;
for (i = 0; i < l; i++) {
  selElmnt = x[i].getElementsByTagName("select")[0];
  ll = selElmnt.length;
  /*for each element, create a new DIV that will act as the selected item:*/
  a = document.createElement("DIV");
  a.setAttribute("class", "select-selected");
  a.innerHTML = selElmnt.options[selElmnt.selectedIndex].innerHTML;
  x[i].appendChild(a);
  /*for each element, create a new DIV that will contain the option list:*/
  b = document.createElement("DIV");
  b.setAttribute("class", "select-items select-hide");
  for (j = 0; j < ll; j++) {
	/*for each option in the original select element,
	create a new DIV that will act as an option item:*/
	c = document.createElement("DIV");
	c.innerHTML = selElmnt.options[j].innerHTML;
	c.addEventListener("click", function(e) {
		/*when an item is clicked, update the original select box,
		and the selected item:*/
		var y, i, k, s, h, sl, yl;
		s = this.parentNode.parentNode.getElementsByTagName("select")[0];
		sl = s.length;
		h = this.parentNode.previousSibling;
		for (i = 0; i < sl; i++) {
		  if (s.options[i].innerHTML == this.innerHTML) {
			s.selectedIndex = i;
			h.innerHTML = this.innerHTML;
			y = this.parentNode.getElementsByClassName("same-as-selected");
			yl = y.length;
			for (k = 0; k < yl; k++) {
			  y[k].removeAttribute("class");
			}
			this.setAttribute("class", "same-as-selected");
			break;
		  }
		}
		h.click();
	});
	b.appendChild(c);
  }
  x[i].appendChild(b);
  a.addEventListener("click", function(e) {
	  /*when the select box is clicked, close any other select boxes,
	  and open/close the current select box:*/
	  e.stopPropagation();
	  closeAllSelect(this);
	  this.nextSibling.classList.toggle("select-hide");
	  this.classList.toggle("select-arrow-active");
	});
}
function closeAllSelect(elmnt) {
  /*a function that will close all select boxes in the document,
  except the current select box:*/
  var x, y, i, xl, yl, arrNo = [];
  x = document.getElementsByClassName("select-items");
  y = document.getElementsByClassName("select-selected");
  xl = x.length;
  yl = y.length;
  for (i = 0; i < yl; i++) {
	if (elmnt == y[i]) {
	  arrNo.push(i)
	} else {
	  y[i].classList.remove("select-arrow-active");
	}
  }
  for (i = 0; i < xl; i++) {
	if (arrNo.indexOf(i)) {
	  x[i].classList.add("select-hide");
	}
  }
}
/*if the user clicks anywhere outside the select box,
then close all select boxes:*/
document.addEventListener("click", closeAllSelect);
</script>

</body>
</html>

